package com.bergerkiller.bukkit.nolagg.sending;

import java.io.DataOutputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.Map;
import java.util.logging.Level;

import com.bergerkiller.bukkit.nolagg.NoLagg;
import com.bergerkiller.bukkit.nolagg.Util;
import com.bergerkiller.bukkit.nolagg.datapool.Pool;
import com.bergerkiller.bukkit.nolagg.datapool.PoolBuffer;
import com.bergerkiller.bukkit.nolagg.datapool.PoolByteBuffer;
import com.bergerkiller.bukkit.nolagg.datapool.PoolData;

import net.minecraft.server.Packet;
import net.minecraft.server.Packet51MapChunk;

@SuppressWarnings({ "unchecked", "rawtypes" })
public class BufferedPacket51MapChunk extends Packet51MapChunk implements PoolData<PoolByteBuffer> {
	
	public static String getBufferSizeName() {
		int size = pool.getDataSize() / 1000;
		if (size < 1000) {
			return size + " kb";
		} else {
			return Util.round((double) size / 1000, 1) + " mb";
		}
	}
	private static Pool<PoolByteBuffer> pool = new Pool<PoolByteBuffer>(21);
		
	@Override
	public PoolByteBuffer getNewData() {
		return new PoolByteBuffer(8192);
	}
		
	private PoolBuffer<PoolByteBuffer> buffer;
	public BufferedPacket51MapChunk(int x, int z, final byte[] rawdata) {
		this.buffer = pool.create(this);
	    super.buffer = this.buffer.getData().data;
		this.rawData = rawdata;
        this.a = x << 4;
        this.c = z << 4;
        this.d = this.f = 16;
        this.e = 128;   
	}
	
	public void writeBuffer(final byte[] source) {
		System.arraycopy(source, 0, super.buffer, 0, this.size);
	}
	public void prepareBuffer() {
		if (super.buffer.length < this.size) {
			super.buffer = new byte[this.size + 200];
			this.buffer.getData().data = super.buffer;
		}
	}
		
	public void a(DataOutputStream dataoutputstream) throws IOException {
		super.a(dataoutputstream);
		if (this.buffer == null) return;
		this.buffer.setFree(this);
		this.buffer = null;
	}
		
	static {
		try {
			Field a = Packet.class.getDeclaredField("a");
			a.setAccessible(true);
			Map map = (Map) a.get(null);
			map.put(BufferedPacket51MapChunk.class, 51);
			j.a(51, BufferedPacket51MapChunk.class);
		} catch (Exception e) {
			NoLagg.log(Level.SEVERE, "Failed to bind to map packet chunk, total failure imminent!");
			e.printStackTrace();
		}
	}


}
